package cse230lab1;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.io.*;

/**
 * <p>Title: Haibei's Tic Tac Toe</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Haibei Zhang
 * @version 1.0
 */

public class Frame1 extends JFrame {
  private JPanel contentPane;
  private BorderLayout borderLayout1 = new BorderLayout();
  private TitledBorder titledBorder1;
  private JPanel jPanel1 = new JPanel();
  private JPanel jPanel2 = new JPanel();

  private TitledBorder titledBorder2;
  private GridLayout gridLayout1 = new GridLayout();


  private JPanel jPanel3 = new JPanel();
  private JLabel label1 = new JLabel();
  private BorderLayout borderLayout2 = new BorderLayout();
  private Vector buttonVector=new Vector();
  private JButton save = new JButton();
  private JButton load = new JButton();
  private GridLayout gridLayout2 = new GridLayout();
  private JButton start = new JButton();
  private int status=0;
  private int turn=0;
  private String textFile="tttgame.txt";
  private BufferedWriter bw;
  private BufferedReader br;

  //Construct the frame
  public Frame1() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Frame1.class.getResource("[Your Icon]")));


    contentPane = (JPanel) this.getContentPane();
    titledBorder2 = new TitledBorder("");
    contentPane.setBackground(Color.lightGray);
    contentPane.setBorder(titledBorder1);
    titledBorder1 = new TitledBorder("");
    contentPane.setLayout(borderLayout1);
    this.setResizable(false);
    this.setSize(new Dimension(353, 300));
    this.setTitle("Tic Tac Toe - Haibei Zhang");


    jPanel1.setBorder(titledBorder1);
    jPanel1.setLayout(gridLayout1);
    jPanel2.setBackground(Color.lightGray);
    jPanel2.setBorder(BorderFactory.createLoweredBevelBorder());
    jPanel2.setLayout(gridLayout2);
    gridLayout1.setColumns(3);
    gridLayout1.setHgap(5);
    gridLayout1.setRows(3);
    gridLayout1.setVgap(5);
    borderLayout1.setVgap(5);

    for (int i=0;i<9;i++)
      {
      buttonVector.add(i, new JButton());
      ((JButton)buttonVector.elementAt(i)).setFont(new java.awt.Font("Dialog", 1, 20));
      ((JButton)buttonVector.elementAt(i)).setForeground(Color.green);
      ((JButton)buttonVector.elementAt(i)).setEnabled(false);
      ((JButton)buttonVector.elementAt(i)).addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
        play(e);
        }
      });

    jPanel1.add((JButton)buttonVector.elementAt(i), null);
    }

    label1.setBackground(Color.lightGray);
    label1.setFont(new java.awt.Font("Dialog", 1, 18));
    label1.setForeground(Color.blue);
    refreshLabel();
    jPanel3.setLayout(borderLayout2);
    jPanel3.setBackground(Color.lightGray);

    save.setText("Save");
    save.setEnabled(false);
    save.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        save_actionPerformed(e);
      }
    });

    load.setText("Load");
    load.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        load_actionPerformed(e);
      }
    });
    gridLayout2.setRows(3);
    gridLayout2.setVgap(50);
    start.setText("Start");
    start.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        start_actionPerformed(e);
      }
    });
    contentPane.add(jPanel2, BorderLayout.EAST);
    jPanel2.add(start, null);
    jPanel2.add(save, null);
    jPanel2.add(load, null);

    contentPane.add(jPanel1, BorderLayout.CENTER);

    contentPane.add(jPanel3, BorderLayout.SOUTH);
    jPanel3.add(label1, BorderLayout.CENTER);



  }

  private void enableAll()
  {
    for (int i=0;i<9;i++)
      ((JButton)buttonVector.elementAt(i)).setEnabled(true);
  }

  private void disableAll()
  {
    for (int i=0;i<9;i++)
      ((JButton)buttonVector.elementAt(i)).setEnabled(false);
  }


  private boolean checkOneRow(int a, int b, int c)
  {
    if(
      (((JButton)buttonVector.elementAt(a)).getText().equalsIgnoreCase(((JButton)buttonVector.elementAt(b)).getText()))
      &&
      (((JButton)buttonVector.elementAt(b)).getText().equalsIgnoreCase(((JButton)buttonVector.elementAt(c)).getText()))
      &&!(((JButton)buttonVector.elementAt(b)).getText().equalsIgnoreCase("-"))
      )
      return true;
    else return false;
  }

  private boolean checkGame()
  {
    return checkOneRow(0,1,2)
        || checkOneRow(3,4,5)
        || checkOneRow(6,7,8)
        || checkOneRow(0,3,6)
        || checkOneRow(1,4,7)
        || checkOneRow(2,5,8)
        || checkOneRow(0,4,8)
        || checkOneRow(2,4,6);
  }

  private void refreshLabel()
  {
    if(status==0) label1.setText("Click Start to play.");
    if(status==1) label1.setText("Player 1's turn(O).");
    if(status==2) label1.setText("Player 2's turn(X).");
    if(status==3)
      {
      label1.setText("Game Over, Player 1 wins.");
      start.setEnabled(true);
      save.setEnabled(true);
      disableAll();
      }
    if(status==4)
      {
      label1.setText("Game Over, Player 2 wins.");
      start.setEnabled(true);
      save.setEnabled(true);
      disableAll();
      }
    if(status==5)
    {
    label1.setText("Game Over, Player draw.");
    start.setEnabled(true);
    save.setEnabled(true);
    disableAll();
    }
  }

  void play(ActionEvent e) {
   if (status==1)
     ((JButton)e.getSource()).setText("O");
   if (status==2)
     ((JButton)e.getSource()).setText("X");
   turn++;
   ((JButton)e.getSource()).setEnabled(false);

   if (checkGame())
     {
       status+=2;
       refreshLabel();
     }
     else if (turn==9)
     {
       status=5;
       refreshLabel();
     }

     else
     {
       status=3-status;
       refreshLabel();
     }


  }

  void start_actionPerformed(ActionEvent e) {
    start.setEnabled(false);
    save.setEnabled(false);
    status=1;
    turn=0;
    refreshLabel();
    enableAll();
    for(int i=0;i<9;i++)
        ((JButton)buttonVector.elementAt(i)).setText("-");

  }



  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void save_actionPerformed(ActionEvent e) {

    String line="";
    for(int i=0;i<9;i++)
      line=line+((JButton)buttonVector.elementAt(i)).getText()+" ";
    try
      {
      bw=new BufferedWriter(new FileWriter(textFile));
        bw.write(line);
        bw.newLine();
        bw.write(""+status);
        bw.close();
      }
    catch(IOException ioe)
      {
        label1.setText("Error saving to "+textFile);
        return;
      }
    label1.setText(label1.getText()+" (Saved)");

  }

  void load_actionPerformed(ActionEvent e) {
    String line="";

    try
      {
          br=new BufferedReader(new FileReader(textFile));
      if(br.ready())
        {
          line = br.readLine();
          StringTokenizer st = new StringTokenizer(line);

          for(int i=0;i<9;i++)
            if (st.hasMoreTokens())
                 ((JButton)buttonVector.elementAt(i)).setText(st.nextToken().trim());
        }
      if(br.ready())
        {
          line=br.readLine();
          status=(new Integer(line.trim())).intValue();
        }
      br.close();
      }
    catch (IOException ioe)
     {
          label1.setText("Error loading from "+textFile);
     }

    refreshLabel();
    label1.setText(label1.getText()+" (Loaded)");
  }

}